cascading.flow.stream.element

## Class MemorySpliceGate

- java.lang.Object
- - cascading.flow.stream.duct.Duct<Incoming,Outgoing>
  - - cascading.flow.stream.duct.Gate<Incoming,Outgoing>
    - - cascading.flow.stream.element.SpliceGate<TupleEntry,Grouping<TupleEntry,TupleEntryIterator>>
      - - cascading.flow.stream.element.GroupingSpliceGate
        - - cascading.flow.stream.element.MemorySpliceGate

- All Implemented Interfaces:
    Collapsing, Window, ElementDuct
  Direct Known Subclasses:
    LocalGroupByGate, MemoryCoGroupGate, MemoryHashJoinGate

      public abstract class MemorySpliceGate
      extends GroupingSpliceGate

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class cascading.flow.stream.element.GroupingSpliceGate

      `GroupingSpliceGate.DelegatedTuple`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected MemoryCoGroupClosure` | `closure`
    `protected AtomicInteger` | `count`
    `protected Set<Tuple>` | `keys`
    `protected Map<Tuple,Collection<Tuple>>[]` | `keyValues`
    `protected int` | `numIncomingEventingPaths`

    - ### Fields inherited from class cascading.flow.stream.element.GroupingSpliceGate

      `groupComparators, groupHasher, grouping, groupSortTuple, groupTuple, keyBuilder, keyEntry, keyFields, keyTuple, nullsAreNotEqual, ordinalMap, sortBuilder, sortFields, tupleEntryIterator, valueComparators, valuesBuilder, valuesFields, valueTuple`

    - ### Fields inherited from class cascading.flow.stream.element.SpliceGate

      `flowProcess, incomingScopes, outgoingScopes, role, splice`

    - ### Fields inherited from class cascading.flow.stream.duct.Duct

      `next, ordinal`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MemorySpliceGate(FlowProcess flowProcess, Splice splice)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `bind(StreamGraph streamGraph)`
    `protected TupleBuilder` | `createDefaultNarrowBuilder(Fields incomingFields, Fields narrowFields)`
    `protected Set<Tuple>` | `createKeySet()`
    `protected Map<Tuple,Collection<Tuple>>[]` | `createKeyValuesArray()` This lets us just replace an old map and let the gc cleanup, vs clearing each map
    `protected Map<Tuple,Collection<Tuple>>` | `createTupleMap()`
    `void` | `initialize()` Called immediately after bind
    `protected abstract boolean` | `isBlockingStreamed()`
    `void` | `prepare()`

    - ### Methods inherited from class cascading.flow.stream.element.GroupingSpliceGate

      `cleanup, createNarrowBuilder, createNulledBuilder, equals, getDelegatedTuple, getKeyComparator, getNumDeclaredIncomingBranches, hashCode, initComparators, setOrdinalMap, toString`

    - ### Methods inherited from class cascading.flow.stream.element.SpliceGate

      `getBranchNames, getFlowElement, getIncomingScopes, getOutgoingScopes, getSplice, handleException, handleReThrowableException, hasTrapHandler, setBranchNames, setTrapHandler`

    - ### Methods inherited from class cascading.flow.stream.duct.Duct

      `complete, getNext, getNextFor, receive, receiveFirst, start`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### keys

          protected Set<Tuple> keys

    - #### keyValues

          protected Map<Tuple,Collection<Tuple>>[] keyValues

    - #### closure

          protected MemoryCoGroupClosure closure

    - #### numIncomingEventingPaths

          protected int numIncomingEventingPaths

    - #### count

          protected final AtomicInteger count

  - ### Constructor Detail

    - #### MemorySpliceGate

          public MemorySpliceGate(FlowProcess flowProcess,
                          Splice splice)

  - ### Method Detail

    - #### bind

          public void bind(StreamGraph streamGraph)

      Overrides:
        `bind` in class `GroupingSpliceGate`

    - #### createDefaultNarrowBuilder

          protected TupleBuilder createDefaultNarrowBuilder(Fields incomingFields,
                                                Fields narrowFields)

      Overrides:
        `createDefaultNarrowBuilder` in class `GroupingSpliceGate`

    - #### initialize

          public void initialize()

      Description copied from class: `Duct`
      Called immediately after bind
      Overrides:
        `initialize` in class `GroupingSpliceGate`

    - #### prepare

          public void prepare()

      Overrides:
        `prepare` in class `Duct<TupleEntry,Grouping<TupleEntry,TupleEntryIterator>>`

    - #### createKeySet

          protected Set<Tuple> createKeySet()

    - #### createKeyValuesArray

          protected Map<Tuple,Collection<Tuple>>[] createKeyValuesArray()

      This lets us just replace an old map and let the gc cleanup, vs clearing each map
      Returns:
        of type Map

    - #### createTupleMap

          protected Map<Tuple,Collection<Tuple>> createTupleMap()

    - #### isBlockingStreamed

          protected abstract boolean isBlockingStreamed()

Copyright © 2007-2015 Concurrent, Inc. All Rights Reserved.